"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  usePointerEvents: () => usePointerEvents
});
module.exports = __toCommonJS(src_exports);
var import_react = require("react");
var import_use_callback_ref = require("@webbo-ui/use-callback-ref");
var usePointerEvents = (props = {}) => {
  const {
    onPointerDown: onPointerDownProp,
    onPointerUp: onPointerUpProp,
    onPress
  } = props;
  const pointerRef = (0, import_react.useRef)(false);
  const onPointerDown = (0, import_use_callback_ref.useCallbackRef)((e) => {
    onPointerDownProp?.(e);
    pointerRef.current = true;
    ["pointerup", "pointercancel", "keydown"].forEach(
      (event) => document.addEventListener(
        event,
        () => {
          pointerRef.current = false;
        },
        { once: true }
      )
    );
  });
  const onPointerUp = (0, import_use_callback_ref.useCallbackRef)((e) => {
    onPointerUpProp?.(e);
    if (pointerRef.current === true && e.button === 0) {
      onPress?.(e);
    }
    pointerRef.current = false;
  });
  return { onPointerDown, onPointerUp };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  usePointerEvents
});
